//
//  CancelBtnNode.swift
//  GoldWars
//
//  Created by Chauntalle Schüle on 15.05.20.
//  Copyright © 2020 SP2. All rights reserved.
//

import SpriteKit

class CancelBtnNode: SKSpriteNode {
    
    var isEnabled: Bool{
        didSet{
            if isEnabled {
                self.alpha = 1
                self.childNode(withName: "label")?.alpha = 1
            } else {
                self.alpha = 0.3
                self.childNode(withName: "label")?.alpha = 0.3
            }
        }
    }
    
    let onButtonPress: () -> ()
    
    init(iconName: String, text: String, isEnabled: Bool, position: CGPoint, onButtonPress: @escaping () -> ()) {
        self.onButtonPress = onButtonPress
        self.isEnabled = isEnabled
        let texture = SKTexture(imageNamed: "yellow_cross")
        super.init(texture: texture, color: SKColor.white, size: texture.size())
        self.size = CGSize(width: 30, height: 30)
        self.position = position
        isUserInteractionEnabled = true
    }
    
    override func touchesBegan(_ touches: Set<UITouch>, with event: UIEvent?) {
        if isEnabled {
            let action = SKAction.sequence(
                [
                    SKAction.scale(by: (3/4), duration: 0.3),
                    SKAction.scale(by: (4/3), duration: 0.3),
                ]
            )
            
            self.childNode(withName: "label")?.run(action)
            self.run(action)
            onButtonPress()
        }
    }
    
    
    required init?(coder aDecoder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    
}
